<?php
defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'functions.php');
require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS.'com_agora.php');

jimport ( 'joomla.plugin.plugin' );


class plgContentAgoraDiscuss extends JPlugin {

	var $hfunc;

	var $db;

	var $discuss;

	function plgContentAgoraDiscuss(&$subject, $config) {

		parent::__construct ( $subject, $config );

		global $mainframe;

		$document = & JFactory::getDocument ();

	   	// Load language
	       	JPlugin::loadLanguage ( 'plg_content_agoradiscuss', JPATH_ADMINISTRATOR );

		$this->hfunc = & HelperFunctions::getInstance();

		$this->db = & JFactory::getDBO();

		$this->discuss = & Discuss::getInstance();

		// Add style sheet
        	$document->addStyleSheet ($this->hfunc->getSiteURL() . 'plugins/content/agoradiscuss/css/Agora/agorathone.css' );

		$this->hfunc->setEnableError(1);

	}
	function onAfterDisplayContent( &$row, &$params, $page=0 ){

		if (!($row->id)) {

			return;

		}

		$this->plgDisplay($row, $params, $page, $cfg);

	}

	/*this function will add like to first postadd post*/
	function plgDisplay(&$row, &$params, &$page, &$cfg){

		$cfg	= array();

		$regex = '/\{discuss\s*.*?}/i';

		$cfg['regex']= $regex;

		$text ='';

		$cfg['artId']= -1;

		$cfg['forumId']= -1;

		$cfg['topicId']= -1;

		// simple performance check to determine whether bot should process further
		$plugin = & JPluginHelper::getPlugin ( 'content', 'agoradiscuss' );

        	$pluginParams = new JParameter ( $plugin->params );

        	$this->params  = $pluginParams->_registry['_default']['data'];

		if ( !$pluginParams->get( 'enabled', 1 ) ) {

    			$row->text = preg_replace( $regex, '', $row->text  );

    			return true;

	    	}

		$cfg['showfirstpost']=$this->params->agora_first_posts; //displayfirst post

		$cfg['sig']=$this->params->agora_signature; //display signature at bottom of the post

		$cfg['reqd']= $this->params->agora_use_button_reqd; //display REQD as image or text

		$cfg['postlimit']= $this->params->agora_post_limit; //How many post to be display

		$cfg['order']=$this->params->agora_last_post_top; //Asc or Desc order

		$cfg['dissbtn']= $this->params->agora_use_button; //Use main discuss button or no

		$cfg['topiclink']= $this->params->agora_show_topic_link; // Show topic link on the top

		$cfg['expand']= $this->params->agora_expand_posts; // Expan post on load of the page or not

		$cfg['cpcontent']= $this->params->agora_copy_content; // On the first what will be post

		$cfg['adddesc']= $this->params->agora_add_topic_description; // add description to a topic

		$cfg['redirection']= $this->params->agora_on_first_redirection; // on first add redirection

		$cfg['rowId'] = $row->id; //Real ID of the article

		$cfg['row'] = & $row;

		$cfg['userid']= '-1';

		$cfg['postuserid']= '-1';


			// find all instances of plugin and put in $matches

			$regex = $cfg['regex'];

	    		preg_match_all( $regex, $row->text, $matches );

	    		// Number of plugins

		     	$count = count( $matches[0] );

		     	if ( $count ) {

				$request_forumId	= array();

		 		for($i=0; $i < $count; $i ++)

    				{

					$cfg['rowId'] = $row->id;

					$forumId = str_replace ( 'discuss', '', $matches [0] [$i] );

					$forumId = str_replace ( 'forum:', '', $forumId );

					$forumId = str_replace ( '{', '', $forumId );

					$forumId = str_replace ( '}', '', $forumId );

					$forumId = trim ( $forumId );

					$cfg['forumId']  = trim ( $forumId );

					$cfg['useraccess'] = $this->plgGetUserPermision($cfg);

					$text = $this->plgDisplayDiscuss($row, $params, $page, $cfg);

					$row->text = str_replace( $matches[0][$i], $text, $row->text );
				}
			}

			unset($cfg);

			$row->text = preg_replace( $regex, '', $row->text  );


	}


	function plgDisplayDiscuss(&$row, &$params, &$page, &$cfg){

					$access = $cfg['useraccess'];

					//echo $this->hfunc->getArrayValues($cfg['useraccess']);

					$request_forumId = $this->plgProccessRequest($cfg);

					if ($request_forumId['addtopic'] !=""){ //chk those somebody puss the button

						//Some values are submited

						$cfg['artId']= $request_forumId['id_art']; //ID of the article received by pressing on button

						$cfg['forumId']  =  $request_forumId['addtopic_id_forum'];

						if ($cfg['artId']==$cfg['rowId']){
							//
							if (!$this->discuss->IsBanned()){ // Is user ban from posting

								$cfg['topicId'] = $this->plgVerifayExistanceOfTopic($cfg);

								if ($cfg['topicId']){

									$text = $this->plgCollapseOrExpandOrLink($cfg);

								}else{


										$cfg['topicId'] = $this->plgCreateRecordInAgoraTopicTable($cfg);

										if ($this->plgCreateRecordInAgoraDiscussTable($cfg)==False){

											$this->plgDeleteRecordInAgoraTopicTableAndAgoraDiscussTable($cfg);

											$cfg['topicId'] = $this->plgVerifayExistanceOfTopic($cfg);

											$text = $this->plgCollapseOrExpandOrLink($cfg);

										}else{

											if ($cfg['redirection']==1){

												$this->RedirectURL($cfg);

											}

											$text = $this->plgCollapseOrExpandOrLink($cfg);

										}


								}

							}else{

								$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

							}

						}else{ //It is not, check does this artical have topic and post, and if has display

							if ($this->plgVerifyExistanceOfRecord($cfg)){

								$cfg['topicId'] = $this->plgVerifayExistanceOfTopic($cfg);

								if ($request_forumId['displaytposts'] !=""){

									$cfg['artId'] =  str_replace ($cfg['forumId'].':', '', $request_forumId['displaytposts'] );

									if ($cfg['artId']==$cfg['rowId']){

										$content = $this->plgGetPosts($cfg);

										$text = implode("\n",$content);

									}else{

										$text = $this->plgCollapseOrExpandOrLink($cfg);

									}

								}elseif ($request_forumId['showtopicId'] !=""){

									$text ='ERROR';

								}else{

									$text = $this->plgCollapseOrExpandOrLink($cfg);

								}

							}else{

								$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

							}

						}

					}else{ //first show of the articles, run display if has topic if does not add button for adding new topic

						if ($this->plgVerifyExistanceOfRecord($cfg)){

							$cfg['topicId'] = $this->plgVerifayExistanceOfTopic($cfg);

							if ($request_forumId['displaytposts'] !=""){

								$cfg['artId'] =  str_replace ( $cfg['forumId'].':', '', $request_forumId['displaytposts'] );

								if ($cfg['artId']==$cfg['rowId']){

									$content = $this->plgGetPosts($cfg);

									if (empty($content)){

										if ($this->plgCreateRecordInAgoraDiscussTable($cfg)==False){

											$this->plgDeleteRecordInAgoraTopicTableAndAgoraDiscussTable($cfg);

											$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

										}else{

											if ($cfg['redirection']==1){

												$this->RedirectURL($cfg);

											}

											$text = $this->plgCollapseOrExpandOrLink($cfg);

										}

									}else{

										$text = implode("\n",$content);

									}

								}else{

										$text = $this->plgCollapseOrExpandOrLink($cfg);

								}

							}elseif ($request_forumId['showtopicId'] !=""){


								$content = $this->plgGetPosts($cfg);

								if (empty($content)){

										$text = $this->plgCollapseOrExpandOrLink($cfg);


								}else{

									$text = implode("\n",$content);

								}

							}else{

								if ($this->plgVerifayExistanceOfTopic($cfg)){

									$num = $this->plgGetPostCount($cfg);

									if ($num==0){

										if (!$this->discuss->IsBanned()){ // Is user ban from posting


												$this->plgCreatePostInAgoraPostTable($cfg);

												$text = $this->plgCollapseOrExpandOrLink($cfg);


										}else{

											$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

										}

									}else{

										$text = $this->plgCollapseOrExpandOrLink($cfg);

									}

								}else{

									$this->plgDeleteRecordInAgoraTopicTableAndAgoraDiscussTable($cfg);

									$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

								}

							}

						}else{

							$text = implode("\n", $this->plgGetAddButtonOrText($cfg));

						}
					}

					return $text;


	}


	function plgProccessRequest($cfg){

		$content	= array();

		$content['id_art'] =  '';

		$content['addtopic_id_forum'] = '';

		$content['addtopic'] ='';

		$content['displaytposts'] ='';

		$content['addtopic'] = JRequest::getVar('discuss_addtopic', '', 'POST' ); //get var from $_POST

		$content['displaytposts'] = JRequest::getVar('discuss_displaytposts', '', 'POST' ); //get var from $_POST

		$content['showtopicId'] = JRequest::getVar('discuss', '', 'GET' ); // get var from POST

		if ($content['addtopic']!=""){

			$content['id_art'] =  str_replace ( $cfg['forumId'].':', '', $content['addtopic'] );

			$content['addtopic_id_forum'] = str_replace ( ':'.$cfg['rowId'], '', $content['addtopic']);

		}

		return $content;
	}

	function plgCollapseOrExpandOrLink($cfg){

		$text='';

		$content	= array();

		$access = $cfg['useraccess'];

	 	if ($access['read']==1){

		  if ($cfg['expand']==1){

			if($cfg['topicId']){

				$content = $this->plgGetPosts($cfg);

				if (empty($content)){

					$text = implode("\n",$this->plgGetButtonOrTextOrLink($cfg));

				}else{


					$text = implode("\n",$content);

				}

			}

		}elseif ($cfg['expand']==2){

			if($cfg['topicId']){

				$content = $this->plgGetPosts($cfg);

				if (empty($content)){


					$text = implode("\n",$this->plgGetButtonOrTextOrLink($cfg));

				}else{

					if ($this->hfunc->getView()=='a'){

						$text = implode("\n",$content);

					}else{

						$text = implode("\n",$this->plgGetButtonOrTextOrLink($cfg));

					}

				}

			}

		}else{


			$text = implode("\n",$this->plgGetButtonOrTextOrLink($cfg));

		}
		}else{
			$text='';
		}

		return $text;

	}

	/* This function adds button and display num of post on it */
	function plgGetButtonOrTextOrLink($cfg){

		$content	= array();

 		$access = $cfg['useraccess'];

	 	if ($access['read']==1){

		$num_of_posts = $this->plgGetPostCount($cfg);

		  if ($cfg['expand']==2){

			if ($cfg['dissbtn']==1){

				$content[] = '<div class="a_buttons">';

				$content[] = '	<a href="'. $this->hfunc->getUrl($cfg['row']) .'&#35;discuss='.$cfg['topicId'].'" class="a_button">'.JText::_("AGORA_DISCUSS_POSTS").' ('.$num_of_posts.')</a>';

				$content[] = '</div>';

			}else{

				$content[] = '<a href="'.$this->hfunc->getUrl($cfg['row']).'"&#35;discuss='.$cfg['topicId'].'>'.JText::_("AGORA_DISCUSS_POSTS").' ('.$num_of_posts.')</a>';

			}

		  }else{

			if ($cfg['dissbtn']==1){

				$content[] = '<div class="a_buttons">';

				$content[] = '	<a href="javascript:document.getElementById(\'displaytposts'.$cfg['forumId'].$cfg['rowId']. '\').submit();" class="a_button">'.JText::_("AGORA_DISCUSS_POSTS").' ('.$num_of_posts.')</a>';

				$content[] = '	<form method="post" id="displaytposts'.$cfg['forumId'].$cfg['rowId'].'" name="displaytposts'.$cfg['forumId'].$cfg['rowId'].'">';

				$content[] = '	<input type="hidden" name="discuss_displaytposts" value="'.$cfg['forumId'].':'.$cfg['rowId'].'" />';

				$content[] = '	</form>';

				$content[] = '</div>';

			}else{

				$content[] = '<a href="javascript:document.getElementById(\'displaytposts'.$cfg['forumId'].$cfg['rowId']. '\').submit();">'.JText::_("AGORA_DISCUSS_POSTS").' ('.$num_of_posts.')</a>';

				$content[] = '<form method="post" id="displaytposts'.$cfg['forumId'].$cfg['rowId'].'" name="displaytposts'.$cfg['forumId'].$cfg['rowId'].'">';

				$content[] = '<input type="hidden" name="discuss_displaytposts" value="'.$cfg['forumId'].':'.$cfg['rowId'].'" />';

				$content[] = '</form>';

			}

		}

	      }else{

		$content[0]='';

	      }

		return $content;
	}

	/* This function adds button (text and etc) depends on variables*/
	function plgGetAddButtonOrText($cfg){

		$content	= array();

		$access = $cfg['useraccess'];

		if ($access['post_topic']==1){

		  if ($cfg['dissbtn']==1){

			$content[] = '<div class="a_buttons">';

			$content[] = '	<a href="javascript:document.getElementById(\'addtopic'.$cfg['forumId'].$cfg['rowId']. '\').submit();" class="a_button">'.JText::_("AGORA_DISCUSS").'</a>';

			$content[] = '	<form method="post" id="addtopic'.$cfg['forumId'].$cfg['rowId'].'" name="addtopic'.$cfg['forumId'].$cfg['rowId'].'">';

			$content[] = '	<input type="hidden" name="discuss_addtopic" value="'.$cfg['forumId'].':'.$cfg['rowId'].'" />';

			$content[] = '	</form>';

			$content[] = '</div>';

		  }else{

			$content[] = '<a href="javascript:document.getElementById(\'addtopic'.$cfg['forumId'].$cfg['rowId']. '\').submit();">'.JText::_("AGORA_DISCUSS").'</a>';

			$content[] = '<form method="post" id="addtopic'.$cfg['forumId'].$cfg['rowId'].'" name="addtopic'.$cfg['forumId'].$cfg['rowId'].'">';

			$content[] = '<input type="hidden" name="discuss_addtopic" value="'.$cfg['forumId'].':'.$cfg['rowId'].'" />';

			$content[] = '</form>';

		}
	      }else{

		$content[0] = '';
	      }

	  return $content;

	}

	function plgDisplayEditLinks($cfg){

	    $content	= array();

	    $content = $this->plgGetEditLinks($cfg);

	    $access = $cfg['useraccess'];

	    $delete_edit = '0';

	    if ($access['can_moderate']==1){

		$delete_edit='1';

	    }else{

		$cfg['userid'] = $this->discuss->GetUserID();

		if ($cfg['userid']==$cfg['postuserid']){

		  $delete_edit='1';

		}else{

		  $delete_edit='0';

		}
	  }


	 if ($access['post_reply']==1){

	    if ($cfg['reqd']==1){

		$content['reply'] = str_replace( '{rtitle}',JText::_("AGORA_DISCUSS_REPLY_TITLE"), $content['reply']  );

		$content['reply'] = str_replace( '{rlabel}','', $content['reply']  );

		$content['reply'] = str_replace( '{rclass}','a_button_reply', $content['reply']  );

	    }else{

		$content['reply'] = str_replace( '{rtitle}',JText::_("AGORA_DISCUSS_REPLY_TITLE"), $content['reply']  );

		$content['reply'] = str_replace( '{rlabel}',JText::_("AGORA_DISCUSS_REPLY_LABEL"), $content['reply']  );

		$content['reply'] = str_replace( '{rclass}','a_none', $content['reply']  );
	    }

	}else{

		$content['reply']='';

	}

	if ($access['post_reply']==1){

	  if ($cfg['reqd']==1){

		$content['quote'] = str_replace( '{qtitle}',JText::_("AGORA_DISCUSS_QUOTE_TITLE"), $content['quote']  );

		$content['quote'] = str_replace( '{qlabel}','', $content['quote']  );

		$content['quote'] = str_replace( '{qclass}','a_button_quote', $content['quote']  );

	    }else{

		$content['quote'] = str_replace( '{qtitle}',JText::_("AGORA_DISCUSS_QUOTE_TITLE"), $content['quote']  );

		$content['quote'] = str_replace( '{qlabel}',JText::_("AGORA_DISCUSS_QUOTE_LABEL"), $content['quote']  );

		$content['quote'] = str_replace( '{qclass}','a_none', $content['quote']  );

	    }

	}else{

		$content['quote']='';

	}

	if ($access['edit_posts']==1 && $delete_edit==1){

	     if ($cfg['reqd']==1){

		$content['edit'] = str_replace( '{etitle}',JText::_("AGORA_DISCUSS_EDIT_TITLE"), $content['edit']  );

		$content['edit'] = str_replace( '{elabel}','', $content['edit']  );

		$content['edit'] = str_replace( '{eclass}','a_button_edit', $content['edit']  );

	    }else{

		$content['edit'] = str_replace( '{etitle}',JText::_("AGORA_DISCUSS_EDIT_TITLE"), $content['edit']  );

		$content['edit'] = str_replace( '{elabel}',JText::_("AGORA_DISCUSS_EDIT_LABEL"), $content['edit']  );

		$content['edit'] = str_replace( '{eclass}','a_none', $content['edit']  );

	    }

	}else{

		$content['edit']='';

	}

	if ($access['delete_posts']==1 && $delete_edit==1){

	    if ($cfg['reqd']==1){

		$content['delete'] = str_replace( '{dtitle}',JText::_("AGORA_DISCUSS_DELETE_TITLE"), $content['delete']  );

		$content['delete'] = str_replace( '{dlabel}','', $content['delete']  );

		$content['delete'] = str_replace( '{dclass}','a_button_delete', $content['delete']  );

	    }else{

		$content['delete'] = str_replace( '{dtitle}',JText::_("AGORA_DISCUSS_DELETE_TITLE"), $content['delete']  );

		$content['delete'] = str_replace( '{dlabel}',JText::_("AGORA_DISCUSS_DELETE_LABEL"), $content['delete']  );

		$content['delete'] = str_replace( '{dclass}','a_none', $content['delete']  );

	    }

	}else{

		$content['delete']='';

	}

	  $text = implode("\n", $content);

	  unset($content);

	  return $text;
	}

	function plgDisplayTopicLink($cfg){

	    $text= '';


	    if ($cfg['topiclink']==1){

		$text = '<h4 class="post-title"><a href="'.$this->plgGetTopicLinks($cfg).'">'.JText::_("AGORA_DISCUSS_GOTO_TOPIC").'</a></h4>';

	    }else{

		$text = '<h4 class="post-title"><a href="#"></a></h4>';

	    }

	    return $text;

	}

	function plgCreatePostInAgoraPostTable($cfg) {


		$row = $cfg['row'];

		$regex = $cfg['regex'];

		$cfg['article_content']= '';



		if ($cfg['cpcontent']=='0'){

			$art_content = '[url]'.$this->hfunc->getUrl($row).'[/url]';

		}elseif($cfg['cpcontent']=='1'){

		        $art_content = preg_replace($regex, "", $row->introtext).' [url]'.$this->hfunc->getUrl($row).'[/url]';

		}elseif	($cfg['cpcontent']=='2'){

			$art_content = preg_replace($regex, "", $row->text).' [url]'.$this->hfunc->getUrl($row).'[/url]';

		}else{

			$art_content = '[url]'.$this->hfunc->getUrl($row).'[/url]';

		}

		$cfg['article_content']= $art_content;

		return $this->plgAddPost($cfg);

	}

	function plgGetPosts($cfg){

		$content	= array();

		$user	= array();

		$posts = $this->_plgGetPosts($cfg);

		$cfg['postId'] = '';

		foreach ($posts as $post)

		{
			$cfg['postId'] = $post['id'];

			$cfg['poster'] = $post['poster'];

			$cfg['message']=$post['message'];

			$cfg['posted']=$post['posted'];

			$user = $this->plgGetUserData($cfg);

			$cfg['postuserid'] = $user['id'];

			$content[] ='<div class="entry">';

  			$content[] ='	<div class="person-info">';

			$content[] ='		<a class="person-info" href="'.$this->plgGetProfileLink($cfg).'" title="'.str_replace( '{title}',JText::_("AGORA_DISCUSS_USER_TITLE"), $user['title']).'">';

			$content[] ='		<img class="face" src="'.$user['avatar'].'" alt="'.$post['poster'].'">';

			$content[] ='		<p class="user-name">'.$post['poster'].'</p></a>';

			$content[] ='	</div>';

			$content[] ='	<div class="post">';

			$content[] ='		<div class="post2">';

			$content[] ='			<div class="post-header">';

			$content[] ='				'.$this->plgDisplayTopicLink($cfg);  //'<h4 class="post-title"><a href="'.$this->discuss->GetTopicLink($topicId).'">'.JText::_("AGORA_DISCUSS_GOTO_TOPIC").'</a></h4>';

			$content[] ='			</div>';

			$content[] ='			<div class="post-contents">';

			$content[] = $this->plgGetSmiliesBBCode($cfg);


			if ($cfg['sig']==1){

				$content[] ='				<p class="post-signature">'.$user['signature'].'</p>';

			}
			//$content[] ='<ul class="related_post">';

			$content[] ='			<div class="post-links">';

			$content[] = $this->plgDisplayEditLinks($cfg); //Add links for edit, relplay add post

			$content[] ='			</div>';

			//$content[] ='</ul>';

			$content[] ='			</div>';

			$content[] ='			<div class="post-footer">';

			$content[] ='				<p>';

			$content[] ='<a style="text-decoration: none;" href="'.$this->plgGetPostLink($cfg).'" title="'.JText::_("AGORA_DISCUSS_GOTO_POST").'">'.$this->plgGetDateTime($cfg).'</a>';

			$content[] ='				</p>';

			$content[] ='			</div>';

			$content[] ='		</div>';

			$content[] ='	</div>';

			$content[] ='</div>';

		}

		return $content;

	}


	/* This function will look up agoradiscuss table for article id */
	function plgVerifyExistanceOfRecord($cfg) {

		$q = 'SELECT content_id FROM #__agora_discussbot WHERE content_id=' . $cfg['rowId'];

		$this->db->setQuery ($q);

		if (! ($list = $this->db->loadObjectList ())) {

			return false;

		} else {

			return true;

		}

	}

	/* This function will add row with article id inside agoradiscuss */
	function plgCreateRecordInAgoraDiscussTable($cfg) {

		$q = 'INSERT INTO #__agora_discussbot (content_id, topic_id) VALUES ('.$cfg['rowId'].', '.$cfg['topicId'].')';

		$this->db->setQuery ($q);

		$this->db->query();

		if ($this->db->getErrorNum()) {

			return false;

		}else{

			return true;

		}

	}

	/* This function will lookup for topic id in agora topic table */
	function plgVerifayExistanceOfTopic($cfg) {

		$q = 'SELECT topic_id FROM #__agora_discussbot WHERE content_id=' . $cfg['rowId'];

		$this->db->setQuery ( $q );

		$lists = $this->db->loadObjectList ();

		if ($this->db->getErrorNum()) {

			return false;

		}else{

			foreach ($lists as $list)

			{

				$res =  $this->plgGetVerifayExistanceOfTopic($list->topic_id);
				if ($res==False){

					return false;
				}else{

					return $res;
				}


			}

		}


	}

	/* This function will add row with article id inside agora topic and return id of the topic */
	function plgCreateRecordInAgoraTopicTable($cfg) {

		global $mainframe;

		$row = $cfg['row'];

		$regex = $cfg['regex'];

		$cfg['article_title'] = '';

		$cfg['article_description'] = '';

		$cfg['article_content']= '';

		if ($cfg['adddesc']==1){

			$document = & JFactory::getDocument ();

			$description = $document->getMetaData( 'description', '' );

		}

		if ($cfg['cpcontent']=='0'){

			$art_content = '[url]'.$this->hfunc->getUrl($row).'[/url]';

		}elseif($cfg['cpcontent']=='1'){

		        $art_content = preg_replace($regex, "", $row->introtext).' [url]'.$this->hfunc->getUrl($row).'[/url]';

		}elseif	($cfg['cpcontent']=='2'){

			$art_content = preg_replace($regex, "", $row->text).' [url]'.$this->hfunc->getUrl($row).'[/url]';

		}else{

			$art_content = '[url]'.$this->hfunc->getUrl($row).'[/url]';

		}

		$cfg['article_title'] = $row->title;

		$cfg['article_description'] = $description;

		$cfg['article_content']= $art_content;

		return $this->plgAddTopic($cfg);

	}

	/* This function will delete records regardin discuss */
	function plgDeleteRecordInAgoraTopicTableAndAgoraDiscussTable($cfg) {

		$q = 'DELETE FROM #__agora_discussbot WHERE content_id='.$cfg['rowId'];

		$this->db->setQuery ($q);

		$this->db->query();

		$this->plgDeleteTopic($cfg);

	}

	/************************************/
	/* Function from functions.php      */
	/************************************/

	function RedirectURL($cfg){

		$this->hfunc->RedirectURL($this->hfunc->getUrl($cfg['row']));

	}

	/************************************/
	/* Function from com_agora.php      */
	/************************************/

	function plgAddTopic($cfg){

		return $this->discuss->AddTopic($cfg['forumId'], $cfg['article_title'], $cfg['article_description'], $cfg['article_content']);

	}

	function plgDeleteTopic($cfg){

		return $this->discuss->DeleteTopic($cfg['topicId']);

	}

	function _plgGetPosts($cfg){

		return $this->discuss->GetPosts($cfg['topicId'], $cfg['order'], $cfg['postlimit'], $cfg['showfirstpost']);

	}

	function plgGetSmiliesBBCode($cfg){

		return $this->discuss->ProcesSmilies($this->discuss->ProcesBBCode($cfg['message']));

	}

	function plgGetUserData($cfg){

		return $this->discuss->GetUserData($cfg['poster']);

	}

	function plgGetProfileLink($cfg){

		return $this->discuss->GetProfileLink($cfg['poster']);

	}

	function plgGetPostLink($cfg){

		return $this->discuss->GetPostLink($cfg['topicId'], $cfg['postId']);

	}

	function plgGetDateTime($cfg){

		return $this->discuss->GetDateTime($cfg['posted']);

	}

	function plgAddPost($cfg){

		return $this->discuss->AddPostToTopic($cfg['topicId'] , $cfg['forumId'], $cfg['article_content']);

	}

	function plgGetPostCount($cfg){

		return $this->discuss->getPostCount($cfg['topicId']);

	}

	function plgGetEditLinks($cfg){

		return $this->discuss->GetEditLinks($cfg['topicId'], $cfg['postId']);

	}

	function plgGetTopicLinks($cfg){

		return $this->discuss->GetTopicLink($cfg['topicId']);

	}

	function plgGetVerifayExistanceOfTopic($cfg){

		return $this->discuss->GetVerifayExistanceOfTopic($cfg);

	}

	function plgGetUserPermision($cfg){

	    $userId = $this->discuss->GetUserID();

	    return $this->discuss->getUserAccess($cfg['forumId'], $userId);

	}
}

?>
