<?php

defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );

@define ('AGORA_TIME',time());

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS.'db.php');

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS.'user.php');

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS. 'parser.php');

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS. 'access.php');

class Discuss

{

		var $db;

		var $table;

		var $order;

		var $auser;

		var $aparser;

		var $useraccess;

		static function & getInstance()

		{

			static $inst;

			if (!isset($inst)) {

				$inst = new Discuss();

			}

			return $inst;

		}



		function __construct()

		{

			$this->useraccess = & AODAccess::getInstance();

			$this->auser = & AUserHelper::getInstance();

			$this->aparser = & AParserHelper::getInstance();

			$this->db = & AgoraDatabase::getInstance('agora_');

			$this->prefix = $this->db->getPrefix().'agora_';

			$this->order = '';

			$data = array();

			$this->aparser->setAgoraConfig($this->auser->getAgoraConfig());

			$this->aparser->setAgoraUserConfig($this->auser->loadCurrent());

			$this->access = array('read','bbcode','bbcode_img','read_rss','post_reply','post_poll','post_topic','edit_topic','edit_posts','delete_topics','delete_posts', 'make_sticky', 'close_topic', 'use_captcha');


		}



		function getForumId($topic_id)

		{

			$this->db->setQuery('SELECT forum_id FROM ##__topics WHERE id = '.intval($topic_id));

			return $this->db->loadResult();

		}

		function getItemId()

		{

			$id='';

			$component	= &JComponentHelper::getComponent('com_agora');

			$menu		= &JSite::getMenu();

			$items		= $menu->getItems('componentid', $component->id);

			if (is_array($items)) {

				$id = '&amp;Itemid='.$items[0]->id;

			}

			return $id;

		}
		function AddPostToTopic($topic_id, $forum_id, $message){

			$user = $this->auser->loadCurrent();

			$message =  strip_tags($message);

			return $this->addPost($topic_id, $forum_id, $message, $user['id'], $user['username'], 0);
		}
		function AddTopic($forumid, $title_of_article, $description ='', $message, $icon ='0'){

			$user = $this->auser->loadCurrent();

			//htmlspecialchars

			//echo 'User='.$user['username'].$user['id'];

			$message =  strip_tags($message);

			return $this->add($forumid, addslashes($title_of_article), $description, $icon, $user['username'], $user['id'],addslashes($message),'False');

		}

		function GetUserID(){

		    $user =  $this->auser->loadCurrent();

		    return $user['id'];

		}

		function GetUserData($user){

			$userId	= array();

			$my = & JFactory::getUser();

			//echo 'User ID='.$my->id.' - ' .$user;

			$userId['jos_id'] = '-1';

			$userId['avatar']='';

			$userId['avatar_size'] ='';

			$userId['id'] = $this->auser->getUserId($user);

			$userId['jos_id'] = $my->id;

			$userId = $this->auser->prepareUserAvatar($userId);

			$userId['title']='{title}'.$this->auser->getUserTitle($user);

			$sig = $this->auser->getUserSignature($user);

			if (!trim($sig)==''){

				$document = & JFactory::getDocument ();

				$document->addScript (JURI::base (). 'components/com_agora/js/slimbox.js' );

				$document->addScript (JURI::base (). 'components/com_agora/js/hide.js' );

			}

			$userId['signature']= $this->aparser->parseSignature($sig);

			//echo 'User Avatars='.$userId['avatar'];

			return $userId;



		}

		function GetEditLinks($topicId, $postId){

			require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');

			$urls = array();

			$urls['reply'] = '<a class="{rclass}" href="'.JRoute::_('index.php?option=com_agora&amp;task=post&amp;page=reply&amp;id='.$topicId.$this->getItemId()).'" title="{rtitle}">{rlabel}</a>';

			$urls['quote'] = '<a class="{qclass}" href="'.JRoute::_('index.php?option=com_agora&amp;task=post&amp;page=reply&amp;action=quote&amp;id='. $postId.$this->getItemId()).'" title="{qtitle}">{qlabel}</a>';

			$urls['edit'] = '<a class="{eclass}" href="'.JRoute::_('index.php?option=com_agora&amp;task=post&amp;page=edit&amp;id='. $postId.$this->getItemId()).'" title="{etitle}">{elabel}</a>';

			$urls['delete'] = '<a class="{dclass}" href="'.JRoute::_('index.php?option=com_agora&amp;task=post&amp;page=delete&amp;id='. $postId.$this->getItemId()).'" title="{dtitle}">{dlabel}</a>';

			return $urls;

		}

		function GetProfileLink($user){

			require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');

			return JRoute::_('index.php?option=com_agora&amp;task=profile&amp;user_id='.$this->auser->getUserId($user).$this->getItemId());

		}

		function GetTopicLink($topicId){

			require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');

			return JRoute::_('index.php?option=com_agora&amp;task=topic&amp;id='.$topicId.$this->getItemId());

		}

		function GetPostLink($topicId, $postId){

			require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');

			return JRoute::_('index.php?option=com_agora&amp;task=topic&amp;id='.$topicId.$this->getItemId().'#p'.$postId);

		}

		function GetPosts($top_id, $reverse = 'True', $total_posts = '', $showfirst = ''){

			return $this->loadPosts($top_id, $reverse, $total_posts, $showfirst);


		}

		function GetVerifayExistanceOfTopic($topicId){

			$q = 'SELECT id FROM ##__topics WHERE id=' .$topicId;

			$this->db->setQuery ( $q );
			return $this->db->loadResult();

		}
		function loadPosts($top_id, $reverse = True, $total_posts ='', $showfirst)

		{



			$sort = '';
			$sf_sql = '';
			if ($reverse) {

				$sort = "DESC";

			} else {

				$sort = "ASC";

			}

			if (!$total_posts==''){

				$total_posts = ' LIMIT '.$total_posts ;

			}
			//echo 'COM ='.$showfirst;
			if ($showfirst==0){
				//echo 'ERGERGRETYREYETret546452634983479804334 3475934 395';
				$num_posts = $this->getPostCount($top_id);
				//echo 'Num of posts='.$num_posts;
				if ($num_posts>1){
					$sf_sql = " AND id<>(SELECT id FROM {$this->prefix}posts WHERE topic_id = {$this->db->Quote($top_id)} ORDER BY posted LIMIT 1)";
				}
			}

			$this->db->setQuery("SELECT * FROM {$this->prefix}posts".

					" WHERE topic_id = {$this->db->Quote($top_id)} $sf_sql".

					" ORDER BY id $sort $total_posts");

			//echo 'SQL='.$this->db->getQuery;

			$posts = $this->db->loadAssocList();

			//echo 'Topic ID='.$top_id;

			return $posts;

		}

		function GetDateTime($timestamp, $date_only = false)

		{

		GLOBAL $time_zone;

		if ($timestamp == '')

			return '';



		$diff = ($time_zone) * 3600;

		$timestamp += $diff;

		$now = time();

		$date = date('d.m.Y', $timestamp);

		$today = date('d.m.Y', $now+$diff);

		$yesterday = date('d.m.Y', $now+$diff-86400);

		if ($date == $today)

			$date = JText::_( 'Today' );

		else if ($date == $yesterday)

			$date = JText::_( 'Yesterday' );

		if (!$date_only)

			return $date.' '.date('H:i:s', $timestamp);

		else

			return $date;

		}




		function addPost($topic_id, $forum_id, $message, $user_id, $username, $hide_smilies)

		{

			// permanently bind common variables (will be used in more then 1 query)

			$this->db->bind('topic_id',$topic_id,'integer',true);

			$this->db->bind('user_name',$username,'string',true);

			$this->db->bind('user_id',$user_id,'integer',true);

			$this->db->bind('timestamp',AGORA_TIME,'integer',true);



			// bind variables just for one query

			$this->db->bind('message',$message,'string');

			$this->db->bind('hide_smilies',$hide_smilies,'integer');



			$id = $this->db->Quote($topic_id);

			$message = $this->db->Quote($message);

			$q_user_id = $this->db->Quote($user_id);

			$user_name = $this->db->Quote($user_name);

			$hide_smilies = $this->db->Quote($hide_smilies);



			$this->db->setQuery('INSERT INTO ##__posts'.

					' (message, poster_id, poster, hide_smilies, posted, topic_id)'.

					' VALUES (:message, :user_id, :user_name, :hide_smilies, :timestamp, :topic_id)');



			$this->db->query();

			$post_id = $this->db->insertid();



			$this->db->bind('post_id',$post_id,'integer',true);



			$this->db->setQuery('UPDATE ##__topics SET'.

					' last_post = :timestamp, '.

					' last_post_id = :post_id,'.

					' last_poster = :user_name,'.

					' num_replies = num_replies+1'.

					' WHERE id=:topic_id');



			$this->db->query();



			$this->db->bind('forum_id',$forum_id,'integer');



			$this->db->setQuery('UPDATE ##__forums SET'.

					' last_post = :timestamp, '.

					' last_post_id = :post_id,'.

					' last_poster = :user_name,'.

					' num_posts = num_posts+1'.

					' WHERE id=:forum_id');



			$this->db->query();



			$this->db->setQuery('UPDATE ##__users SET'.

					' num_posts = num_posts+1, '.

					' last_post = :timestamp' .

					' WHERE id = :user_id');



			$this->db->query();



			$this->db->setQuery('DELETE FROM ##__read_posts WHERE'.

				' user_id <> :user_id AND topic_id = :topic_id');



			$this->db->query();



			// clear permanent bindings

			$this->db->clear();

			$this->markRead($topic_id, $user_id);



			return $post_id;

		}

		function markRead($topic_id, $user_id)

		{

			if ($user_id == 0) return;

			$this->db->bind('user_id',$user_id,'integer',true);

			$this->db->bind('topic_id',$topic_id,'integer',true);



			$this->db->setQuery('DELETE FROM ##__read_posts'.

					' WHERE user_id = :user_id AND topic_id = :topic_id');

			$this->db->query();



			$this->db->bind('time',AGORA_TIME,'integer',true);



			$this->db->setQuery('INSERT INTO ##__read_posts'.

						' (read_time, user_id, topic_id)'.

						' VALUES (:time, :user_id, :topic_id)');



			$this->db->query();



			$this->db->clear();

		}



		function add($forum_id, $subject,$desc,$icon, $user_name, $user_id, $message, $hide_smilies)

		{

			//echo 'com_agora AddTopic';

			$this->db->bind('forum_id',$forum_id,'integer',true);

			$this->db->bind('user_id',$user_id,'integer',true);

			$this->db->bind('user_name',$user_name,'string',true);

			$this->db->bind('timestamp',AGORA_TIME,'integer',true);



			$this->db->bind('subject',$subject,'string');

			$this->db->bind('desc',$desc,'string');

			$this->db->bind('icon',$icon,'string');



			$this->db->setQuery('INSERT INTO ##__topics'.

					 ' (subject,descrip_t, posted, forum_id, icon_topic, poster)'.

					 ' VALUES (:subject, :desc, :timestamp, :forum_id, :icon, :user_name)');



			$this->db->query();



			$topic_id = $this->db->insertid();



			$this->db->bind('topic_id',$topic_id,'integer', true);

			$this->db->bind('hide_smilies',$hide_smilies,'integer');

			$this->db->bind('message',$message,'string');



			$this->db->setQuery('INSERT INTO ##__posts'.

				' (message, poster_id, poster, hide_smilies, posted, topic_id)'.

				' VALUES (:message, :user_id, :user_name, :hide_smilies, :timestamp, :topic_id)');



			$this->db->query();



			$post_id = $this->db->insertid();

			$this->db->bind('post_id',$post_id,'integer', true);



			$this->db->setQuery('UPDATE ##__topics SET'.

					' last_post = :timestamp, '.

					' last_post_id = :post_id,'.

					' last_poster = :user_name,'.

					' num_replies = 0'.

					' WHERE id=:topic_id');



			$this->db->query();



			$this->db->setQuery('UPDATE ##__forums SET'.

					' last_post = :timestamp, '.

					' last_post_id = :post_id,'.

					' last_poster = :user_name'.

					' WHERE id=:forum_id');



			$this->db->query();



			$this->db->clear();



			return $topic_id;



		}

		function DeleteTopic($topicId){

			$this->delete($topicId);

		}

		function delete($id)

		{

			//echo 'Topic ID='.$id;

			$this->db->bind('topic_id',$id,'integer',true);

			$this->db->setQuery('SELECT forum_id FROM ##__topics WHERE id=:topic_id LIMIT 1');

			$forum_id = $this->db->loadResult();





			$this->db->setQuery('DELETE FROM ##__posts WHERE topic_id = :topic_id');

			$this->db->query();



			$this->db->setQuery('DELETE FROM ##__subscriptions WHERE topic_id = :topic_id');

			$this->db->query();



			$this->db->setQuery('DELETE FROM ##__read_posts WHERE topic_id = :topic_id');

			$this->db->query();



			$this->db->setQuery('DELETE FROM ##__topics WHERE id = :topic_id');

			$this->db->query();



			$this->db->clear();

			$this->db->bind('forum_id',$forum_id,'integer', true);



			$this->db->setQuery('SELECT post.id AS post_id, post.poster AS poster, post.posted AS post_time'.

						' FROM ##__posts AS post'.

						'  INNER JOIN ##__topics AS topic'.

						' ON post.topic_id = topic.id'.

						' WHERE topic.forum_id=:forum_id'.

						' ORDER BY post.posted DESC LIMIT 1');



			list($last_post_id, $last_poster, $last_post) = $this->db->loadRow();



			if ($last_post_id) {

				$this->db->bind('last_post_id',$last_post_id,'integer');

				$this->db->bind('last_poster',$last_poster,'string');

				$this->db->bind('last_post',$last_post,'integer');

			} else {

				$this->db->bind('last_post_id','NULL','string');

				$this->db->bind('last_poster','NULL','string');

				$this->db->bind('last_post','NULL','string');

			}



			$this->db->setQuery('UPDATE ##__forums SET last_post=:last_post, last_poster=:last_poster, last_post_id=:last_post_id WHERE id=:forum_id');

			$this->db->query();



			$this->db->clear();



		}

		function ProcesMessage($text, $hide_smilies)

		{

			//global $mainframe;

			$document = & JFactory::getDocument ();

			$document->addScript (JURI::base (). 'components/com_agora/js/slimbox.js' );

			$document->addScript (JURI::base (). 'components/com_agora/js/hide.js' );

			return $this->aparser->parseMessage($text, $hide_smilies);

			//return $this->stripBBCode($text);

		}

		function ProcesBBCode($text)

		{

			//global $mainframe;

			$document = & JFactory::getDocument ();

			//$document->addStyleSheet (JURI::base (). 'components/com_agora/style/Pyxes/js_css/slimbox.css' );

			$document->addScript (JURI::base (). 'components/com_agora/js/slimbox.js' );

			$document->addScript (JURI::base (). 'components/com_agora/js/hide.js' );

			return $this->aparser->bbcode($text);

			//return $this->stripBBCode($text);

		}

		function ProcesSmilies($text)

		{

			return $this->aparser->smilies($text);

		}

		function IsBanned($username = '')

		{

			if (trim($username) =='') {

				$user = $this->auser->loadCurrent();

				$username = strtolower($user['username']);

			}

			//echo 'User Name='.$username;

			if ($username['jos_id'] != 0){

				$this->db->setQuery('SELECT COUNT(*) FROM ##__bans WHERE LOWER(TRIM(username))='.$username);

				return $this->db->loadResult() > 0 ? true : false;

			}else{

				//echo 'fsdf';

				return false;

			}

		}

		function getUserAccess($forum_id, $user_id)
		{

			//echo $forum_id .'-'. $user_id;
			return $this->useraccess->getForumAccess($forum_id, $user_id);

		}

		function getPostCount($topic_id)

		{

			$this->db->setQuery("SELECT COUNT(*) FROM {$this->prefix}posts WHERE topic_id = {$this->db->Quote($topic_id)}");

			return $this->db->loadResult();

		}

		static function escape($key)

		{

			return htmlspecialchars($key, ENT_QUOTES, 'UTF-8');

		}

		static function getRoot()

		{

			return JURI::base().'components/com_agora/';

		}

		static function getCurrentLanguage()

		{

			return JFactory::getLanguage()->getTag();

		}

		static function lang($key)

		{

			static $jlang = null;



			if (is_null($jlang)) {

				$jlang = & JFactory::getLanguage();

			}



			if (is_array($key)) {

				$key = $key[1];

			}



			$result = $jlang->_(trim($key));



			if (defined('AGORA_HELP_TRANSLATE')) {

				echo $key.' '.'&nbsp;-&nbsp;';



				if ($key !== $result && '??'.$key.'??' !== $result) {

					echo 'TRANSLATED';

				} else {

					echo '<b>NOT FOUND</b>';

				}

			print "<br />\n";



			}



			return $result;

		}



}

?>
